// R_VAR.H : Variablen, Konstante f. Radio
// G. TAMM, DF9ZO 1999-2007
//-------------------------
#ifndef _R_VAR_H_
#define _R_VAR_H_
//--------------------
#ifndef _TA_STDAFX_H_
  #include "stdafx.h"
#endif
#ifndef __AFXWIN_H__
  #include <afxwin.h>
#endif
//--------------------
#ifndef _R_STRDIV_H_
  #include "R_STRDIV.H"
#endif
//--------------------
#include "resource.h"
//--------------------
// Disable warning C4786: Symbol greater than 255 character,
#pragma warning(disable: 4786)

#include <list>

using namespace std;
//Specials+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#define             WM_REMDISP_FREQCHANGED    (WM_USER + 1)
#define             WM_REMDISP_STATUSCHANGED  (WM_USER + 2)

extern              CFrameWnd*                PtrToRemDisp;
//Globale Variablen++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
const int 	        Radios_Max			=4;//Max. Anzahl Radios
const int 			IRadios_IB_Max      =4;//Max. Anzahl ICOM-Radios mit CI-V Bus
//-----------------------------------------------------------------------------
//Laengenangaben INKLUSIVE term. '\0'
const int	 	    RStrLt=501,            //max. Laenge normger. Radio-String=201
				    RStrLf=13,             //Laenge Frequenz
				    RStrLm=7,              //Laenge Mode
                    RStrLr=RStrLt-         //Laenge Remarks
                           RStrLf-RStrLm-3,// 2 Trenner + term. '\0'
                    //---------------------------------------------------------
				    RStrSf=0,              //Start Frequenz im String
				    RStrSm=13,             //Start Mode     im String
				    RStrSr=20,             //Start Remarks  im String
                    //---------------------------------------------------------
                    Fl    =150;            //Laenge f. Filenamen
//-----------------------------------------------------------------------------
extern char		    AppName[],
				    InfoStr[],
                    CmdFName[],
				    F_Env[],
                    F_Help[],
                    F_Log[],
                    StatStr[],
                    ComStatStr[],
                    RadioStatStr[];
//-----------------------------------------------------------------------------
extern int          Win_X,Win_Y,Win_W,Win_H;//Fensterposition Hauptfenster
extern int          Win_XIOpos,Win_YIOpos;  //Fensterposition Client
extern long         IdleCount;              
//-----------------------------------------------------------------------------
extern COLORREF     red,black,blue,green,magenta; 
//-----------------------------------------------------------------------------
extern int	        COM_PORT;
extern int			COM_BAUD;
extern int          COM_DATA;
extern int          COM_STOP;
extern int          COM_PARI;
extern int          COM_PROT;
extern int          COM_Poll_Mode;          //0=Cont., 1=Interval     
extern int          COM_Poll_Interval;      //Polling-Rate Interval
extern int          COM_IsPolling;          //Verh. Wiedereintr. bei lfd. Routine
extern UINT         COM_Timer_ID;           //Timer ID
//-----------------------------------------------------------------------------
extern int 			REMO;
extern int 			RemDisp_UPD;
extern int 			SCAN;
extern int 	 		Radio_Num;
//-----------------------------------------------------------------------------
extern char         Fact_s[];				//Frequenz aktuell als String
extern char         Fdef_s[];               //Frequenz default als String
extern char         Flas_s[];               //Frequenz last    als String
extern char         Fold_s[];               //Frequenz old     als String
extern unsigned int Fact_n;                 //Frequenz aktuell als num. Wert
extern unsigned int Fmin_n;
extern unsigned int Fmax_n;
//-----------------------------------------------------------------------------
extern char         SFact_s[];				//Frequenz-Step
extern char			SFdef_s[];
extern unsigned int SFact_n;
//-----------------------------------------------------------------------------
extern char         OFact_s[];				//Frequenz-Offset
extern char			OFdef_s[];
extern int   		OFact_n;
//-----------------------------------------------------------------------------
extern char         Mact_s[];				//Mode
extern char			Mdef_s[];
extern char			Mlas_s[];
extern int			Mact_n;                 //Modeliste Indexierung
extern int			Mlas_n; 

const  int          MaxMOs             =10; //Modes max. verfuegbar
extern int          MaxMOsLe;               //tats. max. Stringlaenge i. Modeliste
extern char         MOs[MaxMOs][RStrLm];    //Modeliste
//-----------------------------------------------------------------------------
extern char         FIact_s[];				//Filterstring f. Anzeige
extern int 			FIact_n;                //Filter Indexierung
extern int 			FIlas_n; 

const  int          MaxFIs             =3;  //Filter max. verfuegbar
extern int          MaxFIsLe;               //tats. max. Strlaenge i. Filterliste 
extern char         FIs[MaxFIs][RStrLm];    //Filterliste
//-----------------------------------------------------------------------------
extern int			ANTsw;                  //ANT     -Switch (0=A1  / 1=A2         )

extern int			ATTsw;                  //ATT     -Switch (0=off / 1=10dB / ... )
extern char         ATT_li_s[4][2];         //ATT     -Liste  (Strings              )

extern int			PAMPsw;                 //PAMP    -Switch (0=off / 1 / 2        )

extern int			AGCsw;                  //AGC     -Switch (0=off / 1=F / 2=S    )

extern int 			DUPsw;                  //DUP     -Switch (0=SIM / 1=  / 2      )

extern int 			VFOsw;                  //VFO     -Switch (0=A   / 1=B          )

extern int 			VMsw;                   //V/M     -Switch (0=VFO / 1=Memory     )

extern int			NBsw;                   //NB      -Switch (0=off / 1=on         )
extern int			NBlev_n;                //NB-Level-Einst. (0-255                )
extern int			NBwid_n;                //NB-Width-Einst. (0-255                )

extern int			NRsw;                   //NR      -Switch (0=off / 1=on         )
extern int			NRlev_n;                //NR-Level-Einst. (0-255                )

extern int			ANFsw;                  //ANF     -Switch (0=off / 1=on         )

extern int   		SQLlev_n;				//SQL-Level-Einst.(0-255                )
extern int   		SQL_oc;					//SQL     -Erg.   (0=closed / 1=open    )
extern int	 		SMlev_n;				//SM      -Erg.   (0-255                )
extern char			SMlev_s[];              //SM      -Anz.   (String               )
extern int			SM_li_n[15];            //SM      -Liste  (num.                 )
extern char			SM_li_s[15][8];         //SM      -Liste  (Strings              )
extern int	 		SM_sel;				    //SM      -Ausw.  (0=num. / 1=S-Wert    )
extern int	 		SQLSM_cont;				//SQL/SM  -Ausw.  (0=Abfrage / 1=cont.  )

extern int 			AFlev_n;                //AF      -Einst. (0-255                )

extern int 			RFlev_n;                //RF      -Einst. (0-255                )

extern int 			PBTH_n;                 //PBT H   -Einst. (0-255                )
extern int 			PBTL_n;                 //PBT L   -Einst. (0-255                )

extern int 			CWSPEED_n;              //CW-SPEED-Einst. (0-255                )

extern int   		TXPWR_n;				//Sendel. -Einst. (0-255                )
extern int   		TXPWR_tune;				//Sendel. -ini-F. (0-255                )

extern int   		RTTY_TPFsw_n;           //TPFilter-Switch (0=off / 1=on         )
extern int          RTTY_KPsw_n;            //Key Pol.-Switch (0=normal / 1=reverse )
extern int          RTTY_MFsw_n;            //Mark-F  -Switch (0-2=1275,1615,2125   )
extern int          RTTY_SHsw_n;            //Shift   -Switch (0-2=170,200,425      )
extern int          RTTY_RXDECsw_n;         //RX-Dec. -Switch (0=CR,LF,CR+LF,1=CR+LF)

extern char			MEMtxt_s[];             //                (String               )
//-----------------------------------------------------------------------------
extern const char   RadAdds_s[7][7];        //zus. Befehle im RadStr
//+Spezifika ICOM CI-V - Bus+++++++++++++++++++++++++++++++++++++++++++++++++++    
//+TIRadioData_IB++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//ICOM CI-V - Bus: 8 Databit / 1 Stopbit / NO Parity / NO Protocol
struct TIRadioData_IB
{
 char    Name[50];  		  //Titel
 //Radio allgemein---------------------
 char    Fdef_s [RStrLf];     //Frequenz def. d. Radios
 char 	 Fmin_s [RStrLf];     //Min. Frequenz d. Radios
 char 	 Fmax_s [RStrLf];     //Max. Frequenz d. Radios
 int 	 SQL_SH;			  //0=Software / 1=Hardware
 char	 SmConv_s[20];	      //S-Meter Konversions-File
 //ICOM CI-V - Bus---------------------
 char    IB_Adr_s[3];  	      //Adresse (String, hex)
 int 	 IB_Da_n;			  //Datalength (4 oder 5) 
 int     IB_DSP_Fi;           //0=HW-Filter, 1=DSP-Filter
 char    IB_Fi_s[18][3];      //SubCmds f. HW-Filter (Strings)
 //REMOTE------------------------------
 char 	 RE_Fact_s [RStrLf];  //F akt.
 int     RE_Mact_n;           //Modeindex akt.
 int     RE_FIact_n;          //FilterIndex: 0=Normal, 1=Narrow, 2=Wide
 char 	 RE_SFact_s[RStrLf];  //F-Step
 char 	 RE_OFact_s[RStrLf];  //F-Offset
 //SCAN--------------------------------
 char    SC_LoF_s[RStrLf];	  //Freq. low
 char    SC_HiF_s[RStrLf];    //Freq. high
 char 	 SC_SFact_s[RStrLf];  //F-Step
 int     SC_Mact_n;           //Modeindex
 int     SC_FIact_n;          //FilterIndex:   0=Normal, 1=Narrow, 2=Wide
 int     SC_StepDel;
 int     SC_StopMo;           //Mode Scanstop: 0=Mode1,  1=Mode2,  2=Mode3
 int     SC_M2Del;
 int     SC_M3Lev;
 int     SC_WrSpec;
 int     SC_LtSpec;
};
extern TIRadioData_IB IRADIO_IB[IRadios_IB_Max];

const int			IB_SoM             =0xFE,
                    IB_EoM             =0xFD,
			 	    IB_PcAdr           =0xE0,
                    IB_OK              =0xFB,//251
                    IB_NOTOK           =0xFA,//250
                    IB_COLL            =0xFC;//252

extern int 			IRadio_IB_Adr_n;     //ICOM-Adresse numerisch
extern int 			IRadio_IB_Da_n;      //ICOM-Data
extern int 			IRadio_IB_SQL_n;     //SW-/HW_SQL
extern int 			IRadio_IB_Conf;      //0=NO Confirmation
extern int 			IRadio_IB_CmdDel;    //Delay zwischen 2 Befehlen [ms]
extern int 			IRadio_IB_DSP_Fi;    //0=HW-Filter, 1=DSP-Filter
extern int          IRadio_IB_Fi_n[];    //Array SubCmds f. Filter
//-----------------------------------------------------------------------------
const  int    		ScLiMax        	   =300;//Scanliste max. Inhalt
extern int          ScLiInd,                //Scanliste Index
                    ScLiNum;                //Scanliste Anz. Elemente

extern int			ScOpMo,					//0=NO Sel., 1=Scan, 2=MScan, 3=Lib
                    ScOpMoFrFile,           //LibFile: 1=Scan, 2=MScan
                    ScStopMo,               //0=Mode1,1=Mode2, 2=Mode3
                    ScIsRu,
                    ScIsSta,
                    ScIsSto,
                    ScIsResta;

extern char         ScLoF_s[],
                    ScHiF_s[];
extern unsigned int	ScLoF_n,
					ScHiF_n;

extern char			ScStepDel_s[],
					ScM2Del_s[],
                    ScM3Lev_s[];
extern int			ScStepDel_n,
					ScM2Del_n,
                    ScM3Lev_n;

extern char         ScStr1[],
                    ScStr2[],
                    ScTime1[],
                    ScTime2[];

extern int 			ScWrSpec,               //0=Scannen / 1=Scannen+Spec schreiben
                    ScLtSpec;               //0=Spec nach j. Durchgang loeschen
                                            //1=Spec nicht loeschen

extern char         F_ScMScanFi[],          //File f. M-Scan (*.fre)
                    F_ScLibFi[];            //File f. Lib    (*.lib)		
                    
struct TScan
{
 char f[ScLiMax][RStrLf];                   //Frequenz
 int  m[ScLiMax];                           //ModeIndex
 int  y[ScLiMax];                           //Y-Achse
};

extern TScan ScAr;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+Messages++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
extern char         msg00[],msg01[],msg02[],msg03[],msg04[],msg05[],
       		 		//-------------------
                    scmsg00[],scmsg01[],scmsg02[],scmsg03[],
                    //-------------------
                    commsg00[],              
       		 		//-------------------
                    statmsg00[],statmsg01[],statmsg02[],statmsg03[],
                    ////ICOM CI-V - Bus--
       		        IB_msg00[],IB_msg01[],IB_msg02[],IB_msg03[],IB_msg04[];
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
extern char         defini01[],defini02[],defini03[],defini04[],defini05[],
                    defini06[],defini07[],defini08[],defini09[],defini10[],
                    defini11[],defini12[],defini13[],defini14[],defini15[],
                    defini16[];
                    
extern char         radini01[],radini02[],radini03[],radini04[],radini05[],
                    radini06[],radini07[],radini08[],radini09[],radini10[],
                    radini11[],radini12[],radini13[],radini14[],radini15[],
                    radini16[],radini17[],radini18[],radini19[],radini20[],
                    radini21[],radini22[];

extern char         scini01[],scini02[],scini03[],scini04[],scini05[],
                    scini06[],scini07[],scini08[],scini09[],scini10[],
                    scini11[],scini12[];

extern char         smcini01[],smcini02[],smcini03[],smcini04[],smcini05[],
                    smcini06[],smcini07[],smcini08[],smcini09[],smcini10[],
                    smcini11[],smcini12[],smcini13[],smcini14[],smcini15[];

extern char         fiini01[],fiini02[],fiini03[],fiini04[];
                    
extern char			IRadio_IB_ini[21][10];////ICOM CI-V - Bus
//+INI-File++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
int RIniFile(void);
//Liest INI-File
//-----------------------------------------------------------------------------
int WIniFile(void);
//Schreibt INI-File
//+LIB-File++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
int RLibFile(char *FName);
//Liest LIB-File
//-----------------------------------------------------------------------------
int WLibFile(char *FName);
//Schreibt LIB-File
//+SMC-File++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
int RSMCFile(char *FName);
//Liest *SMC-File
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+Liste+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
typedef list<CString>  List;
extern  List           Fli;
extern  int            FliMax;
//-----------------------------------------------------------------------------
int  LiReadFile(List& l,int sel,char *fName);
//Liest File ein
void LiRemAllElem(List& l);
//Entfernt alle Elemente aus Liste
void LiGetElemAt(List& l,CString& dest,int pos);
void LiGetElemAt(List& l,char* dest,int pos);
//Kopiert Element an pos in dest
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#endif // _R_VAR_H_
/*
-------------------------------------------------------------------------------
Datenformat fuer FRE-Files:

*.FRE-FILES:

xxxx.xxx,xxx_xxxxxx_123456789a123456789b123456789c123456789d123456789e123456789f
F(12)        M(6)   Additional Data/Remarks
0-11         13-18  20-200

           1_1    1_2
0   4   8  1_3    8_0


Modes:

USB, LSB, FM, FMW, AM, CW, FSK, (SKI)


Additional Data:

>SF=F-Step;        Example: >SF=.025;      / >SF=.012,5;
>OF=F-Offset;      Example: >OF=.6;        / >OF=4.6;
>FI=Filter;        Example: >FI=-;(Normal) / >FI=N;(Narrow) / >FI=W;(Wide)
>ATT=Attenuator;   Example: >ATT=0;        / >ATT=2;
>DUP=Duplex;       Example: >DUP=S;        / >DUP=-;        / >DUP=+;


Example for frequency database files:

    .199,000 AM     BBC                                >SF=.001;
    .846,000 AM     RAI                                >SF=.009;
    .873,000 AM     AFN                                >SF=.009;>ATT=3;
   3.790,000 LSB                                       >SF=.000,1;
   7.002,000 CW                                        >SF=.000,1;>FI=N;
   9.410,000 AM     BBC                                >SF=.005;  
  10.000,000 SKI    Skip this frequency when scanning
  14.313,000 USB    Maritime                           >SF=.000,1;
  89.300,000 FMW    HR3                                >SF=.1;>FI=W;
 145.350,000 FM     OV Hanau(DF9ZO)                    >SF=.025;>OF=.6;
 430.350,000 FM     OV Hanau(DF9ZO)                    >SF=.025;
1295.350,000 FM     OV Hanau(DF9ZO)                    >SF=.025;
-------------------------------------------------------------------------------
*/

