//TaICOM.cpp:
// G.Tamm,DF9ZO 2007
//------------------
#include "TAICOM.h"
//CTheApp++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
CTheApp theApp;

BEGIN_MESSAGE_MAP( CTheApp, CWinApp )
	//{{AFX_MSG_MAP( CTheApp )

	//}}AFX_MSG_MAP
    // Standard print setup command
    ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

BOOL CTheApp::InitInstance()
{
 //Kommandozeile----
 CmdFName[0]='\0';if (m_lpCmdLine[0] != '\0') strcpy(CmdFName,m_lpCmdLine);
 //----------------- 
 m_pMainWnd = new CMainWindow;
 m_pMainWnd->MoveWindow(Win_X,Win_Y,Win_W,Win_H);
 m_pMainWnd->SetWindowText(AppName);
 m_pMainWnd->ShowWindow(m_nCmdShow);
 m_pMainWnd->UpdateWindow();

 return TRUE;
}
//-----------------------------------------------------------------------------
BOOL CTheApp::OnIdle(LONG lCount)
{
 int res;

 if (CWinApp::OnIdle(lCount)) return TRUE;
 
 if (REMO == 1 && COM_Poll_Mode == 0)//ONLY when COM-Polling=Continuous
  {
   if (COM_IsPolling == 0) {res=comport.AskCOM_IDLE();return TRUE;}
  }

 return FALSE;//s. CWinApp::OnIdle
}
//CMainWindow++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
BEGIN_MESSAGE_MAP( CMainWindow, CFrameWnd )
	//{{AFX_MSG_MAP( CMainWindow )
	ON_WM_PAINT()
	ON_WM_CLOSE()
	ON_WM_CREATE()
	ON_WM_SIZE()
	ON_COMMAND(CM_M_ABOUT,            On_M_About)
	ON_COMMAND(CM_M_INFO,             On_M_Info)
	ON_COMMAND(CM_M_EXIT,             On_M_Exit)
	ON_COMMAND(CM_M_RADIO1,           On_M_Radio1)
	ON_COMMAND(CM_M_RADIO2,           On_M_Radio2)
	ON_COMMAND(CM_M_RADIO3,           On_M_Radio3)
	ON_COMMAND(CM_M_RADIO4,           On_M_Radio4)
	ON_COMMAND(CM_M_RADIOPAR1,        On_M_RadioPar1)
	ON_COMMAND(CM_M_RADIOPAR2,        On_M_RadioPar2)
	ON_COMMAND(CM_M_RADIOPAR3,        On_M_RadioPar3)
	ON_COMMAND(CM_M_RADIOPAR4,        On_M_RadioPar4)
	ON_COMMAND(CM_M_REM,              On_M_Rem)
    ON_COMMAND(CM_M_SCAN,             On_M_Scan)
	ON_COMMAND(CM_M_COM_SETTINGS,     On_M_COM_Settings)
	ON_COMMAND(CM_M_COM_CHPORTS,      On_M_COM_ChPorts)
	ON_COMMAND(CM_M_COM_CLRRXBUF,     On_M_COM_ClrRXBuf)
	ON_COMMAND(CM_M_SHOWINFO,         On_M_ShowInfo)	 
	ON_COMMAND(CM_M_ICOM_BUS_SETMEM,  On_M_ICOMBUS_SetMem)
	ON_COMMAND(CM_M_ICOM_BUS_RESMEM,  On_M_ICOMBUS_ResMem)
    ON_COMMAND(CM_M_ICOM_BUS_OPTIONS, On_M_ICOMBUS_Options)
    ON_COMMAND(ID_TEST,               On_ID_Test)
	//}}AFX_MSG_MAP    
END_MESSAGE_MAP()

static UINT indicators[] = // StatusBar
{
 ID_SEPARATOR,           
 //ID_INDICATOR_CAPS,
 //ID_INDICATOR_NUM,
 //ID_INDICATOR_SCRL,
};
//Diagnose---------------------------------------
#ifdef _DEBUG
void CMainWindow::AssertValid() const
{
     
 CFrameWnd::AssertValid();
}
void CMainWindow::Dump(CDumpContext& dc) const
{

 CFrameWnd::Dump(dc);
}
#endif
//-----------------------------------------------------------------------------
CMainWindow::CMainWindow()
{
 CFrameWnd();
 LoadFrame(IDR_MAINFRAME);
 //Initialisierungen---------------
 remdlg=0;remdisp=0;remwin=0;
 scandlg=0;scandisp=0;
 PtrToRemDisp=NULL;
 RIniFile();
 R_Lib_Init();
}

CMainWindow::~CMainWindow()
{
 WIniFile();
}
//-----------------------------------------------------------------------------
int CMainWindow::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
 if (CFrameWnd::OnCreate(lpCreateStruct) == -1) return -1;
 
 if (!m_wndStatusBar.Create(this) ||
	 !m_wndStatusBar.SetIndicators(indicators,
	 sizeof(indicators)/sizeof(UINT))) return -1;

 return 0;
}
//-----------------------------------------------------------------------------
void CMainWindow::OnClose() 
{
 if (REMO || SCAN) return;

 if (remwin     != 0) {remwin  ->DestroyWindow();remwin=0;}
 if (remdlg     != 0) {remdisp ->DestroyWindow();remdisp=0;}
 if (scandlg    != 0) 
  {
   scanview->DestroyWindow();scanview=0;
   scandisp->DestroyWindow();scandisp=0;
  }
 if (_TaMsgWin_ != 0) _TaMsgWin_->DestroyWindow();

 GetWinPars();
 Win_X=XIOpos-Dvframe;
 Win_Y=YIOpos-Dhframe-Hcaption-Hmenue;
 Win_W=XIUpos-XIOpos+(2*Dvframe);
 Win_H=YIUpos-YIOpos+(2*Dhframe)+Hcaption+Hmenue;
 CFrameWnd::OnClose();
}
//-----------------------------------------------------------------------------
void CMainWindow::GetWinPars()
{
 CRect rect;

 GetWindowRect(rect);
 XOpos=rect.left;YOpos=rect.top;XUpos=rect.right;YUpos=rect.bottom;
 //-----------------------------
 Hcaption=GetSystemMetrics(SM_CYCAPTION);
 Hmenue=GetSystemMetrics(SM_CYMENU); 	
 Dvframe=GetSystemMetrics(SM_CYSIZEFRAME);
 Dhframe=GetSystemMetrics(SM_CXSIZEFRAME);
 BVScr=GetSystemMetrics(SM_CXVSCROLL);//Breite vert. Scr
 HHScr=GetSystemMetrics(SM_CYHSCROLL);//Hoehe hor. Scr
 XIOpos=rect.left  +Dvframe;
 YIOpos=rect.top   +Dhframe+Hcaption+Hmenue;
 XIUpos=rect.right -Dvframe;
 YIUpos=rect.bottom-Dhframe;
 //-----------------------------
 icon=::LoadIcon(AfxGetApp()->m_hInstance,MAKEINTRESOURCE(IDR_MAINFRAME));
}
//-----------------------------------------------------------------------------
void CMainWindow::UpDateStatusStr(int mode)
{
 char tmpstr[20],numstr[10];

 itoa(Radio_Num+1,numstr,10);
 if (mode == 1 && Radio_Num == -1) strcpy(StatStr,"Select a radio");
 if (mode == 1 && Radio_Num >= 0) {strcpy(StatStr,statmsg03);strcat(StatStr,numstr);}
 if (mode == 2) {strcpy(StatStr,statmsg01);strcat(StatStr,numstr);}
 if ((mode == 1 && Radio_Num >= 0) || mode == 2)
  {
   if (Radio_Num < IRadios_IB_Max)//ICOM CI-V - Bus
    {
     strcat(StatStr," ( ");strcat(StatStr,IRADIO_IB[Radio_Num].Name);
    }
   wsprintf(tmpstr," , COM%d , %d Bd)",COM_PORT+1,BAUD_n[COM_BAUD]);
   strcat(StatStr,tmpstr);
  }
}

void CMainWindow::UpDateStatusBar()
{
 m_wndStatusBar.SetPaneText(0,StatStr);	
}

void CMainWindow::OnSize(UINT nType, int cx, int cy) 
{
 CFrameWnd ::OnSize(nType, cx, cy);
 Invalidate();
}

void CMainWindow::OnPaint()
{
 CPaintDC   dc(this);
 TEXTMETRIC metric;
 
 dc.GetTextMetrics(&metric);
 SchrH=metric.tmHeight+metric.tmExternalLeading;
 SchrB=metric.tmAveCharWidth+metric.tmOverhang;
 //---------------------------------------------
 UpDateStatusStr(1);UpDateStatusBar();
 //---------------------------------------------
 On_M_ShowInfo();
}
//*****************************************************************************
void CMainWindow::On_M_RadioPar1() 
{
 if (REMO || SCAN) return;
 Radio_Num=0;
 UpDateStatusStr(2);UpDateStatusBar();
 //------------------------------------
 ICOM_BUS_Dlg icomdlg(this);
 icomdlg.TransferToDlg(Radio_Num);
 if (icomdlg.DoModal()==IDOK) icomdlg.TransferFrDlg(Radio_Num);  
 //------------------------------------
 Invalidate();UpDateStatusStr(1);UpDateStatusBar();
}

void CMainWindow::On_M_Radio1() 
{
 if (REMO || SCAN) return;
 Radio_Num=0;
 Invalidate();UpDateStatusStr(1);UpDateStatusBar();
}

void CMainWindow::On_M_RadioPar2() 
{
 if (REMO || SCAN) return;
 Radio_Num=1;
 UpDateStatusStr(2);UpDateStatusBar();
 //------------------------------------
 ICOM_BUS_Dlg icomdlg(this);
 icomdlg.TransferToDlg(Radio_Num);
 if (icomdlg.DoModal()==IDOK) icomdlg.TransferFrDlg(Radio_Num);  
 //------------------------------------
 Invalidate();UpDateStatusStr(1);UpDateStatusBar();
}

void CMainWindow::On_M_Radio2() 
{
 if (REMO || SCAN) return;
 Radio_Num=1;
 Invalidate();UpDateStatusStr(1);UpDateStatusBar();
}

void CMainWindow::On_M_RadioPar3() 
{
 if (REMO || SCAN) return;
 Radio_Num=2;
 UpDateStatusStr(2);UpDateStatusBar();
 //------------------------------------
 ICOM_BUS_Dlg icomdlg(this);
 icomdlg.TransferToDlg(Radio_Num);
 if (icomdlg.DoModal()==IDOK) icomdlg.TransferFrDlg(Radio_Num);  
 //------------------------------------
 Invalidate();UpDateStatusStr(1);UpDateStatusBar();
}

void CMainWindow::On_M_Radio3() 
{
 if (REMO || SCAN) return;
 Radio_Num=2;
 Invalidate();UpDateStatusStr(1);UpDateStatusBar();
}

void CMainWindow::On_M_RadioPar4() 
{
 if (REMO || SCAN) return;
 Radio_Num=3;
 UpDateStatusStr(2);UpDateStatusBar();
 //------------------------------------
 ICOM_BUS_Dlg icomdlg(this);
 icomdlg.TransferToDlg(Radio_Num);
 if (icomdlg.DoModal()==IDOK) icomdlg.TransferFrDlg(Radio_Num);  
 //------------------------------------
 Invalidate();UpDateStatusStr(1);UpDateStatusBar();
}

void CMainWindow::On_M_Radio4() 
{
 if (REMO || SCAN) return;
 Radio_Num=3;
 Invalidate();UpDateStatusStr(1);UpDateStatusBar();	
}

void CMainWindow::On_M_ShowInfo() 
{
 CClientDC dc(this);
 CSize     size;
 CString   str("",200),str1("",200);
 char      tmpstr[200];
 int       s,x,y,z;
 int       y1=SchrH,y2=SchrH+y1;
                       
 if (REMO || SCAN) return;
 x=0;y=0; 
 for (z=1;z < 5;z++)
  {
   if (strcmp(IRADIO_IB[z-1].Name,"") == 0 && strcmp(IRADIO_IB[z-1].IB_Adr_s,"") == 0) continue; 
     
   dc.SetTextColor(red);
   wsprintf(tmpstr,"RADIO %d (ICOM CI-V): ",z);
   str=tmpstr;dc.TextOut(0,y,str);size=dc.GetTextExtent(str);s=size.cx;

   dc.SetTextColor(black);
   str1=IRADIO_IB[z-1].Name;
   str1+=" (";str1+=IRADIO_IB[z-1].IB_Adr_s;str1+="/";
   itoa(IRADIO_IB[z-1].IB_Da_n,tmpstr,10);str1+=tmpstr;str1+=")  ";
   dc.TextOut(s,y,str1);size=dc.GetTextExtent(str1);s+=size.cx;

   dc.SetTextColor(blue);
   str1="F[MHz]: ";
   str1+=IRADIO_IB[z-1].Fmin_s;str1+=" - ";str1+=IRADIO_IB[z-1].Fmax_s;
   dc.TextOut(s,y,str1);

   y+=y2;x=0;
  }

  dc.SetTextColor(black);
  wsprintf(tmpstr,"ICOM CI-V Bus  CMD-Confirmation: %d  CMD-Delay: %d",IRadio_IB_Conf,IRadio_IB_CmdDel);
  str1=tmpstr;dc.TextOut(0,y,str1);
  y+=y2;x=0;

  dc.SetTextColor(black);
  str="Selected Radio: ";
  dc.TextOut(x,y,str);
  size=dc.GetTextExtent(str);
  dc.SetTextColor(red);
  itoa(Radio_Num+1,tmpstr,10);
  str1="RADIO ";str1+=tmpstr;
  dc.TextOut(size.cx,y,str1);
  y+=y1;x=0;
  dc.SetTextColor(black);
  str="(Selection: CTRL+x / Configuration: ALT+x)";
  dc.TextOut(x,y,str);

  y+=y2;x=0;
  dc.SetTextColor(black);
  str="COM Polling-Mode: ";
  if (COM_Poll_Mode == 0) str1="Continuous";
  if (COM_Poll_Mode == 1) 
   {
    str1="Interval=";
    itoa(COM_Poll_Interval,tmpstr,10);strcat(tmpstr," ms");
    str1+=tmpstr;
   }
  str+=str1;
  dc.TextOut(x,y,str); 
}
//*****************************************************************************
void CMainWindow::On_M_Rem() 
{
 if (REMO || SCAN) return;
 Invalidate();
 COMTest_Single(COM_PORT);if (!COMAvail[COM_PORT]) {MyMsgBox(AppName,commsg00,3);return;}
 //-------------------------
 GetWinPars();Win_XIOpos=XIOpos;Win_YIOpos=YIOpos;
 remdlg=new RemDlg(this);
 remdlg->Create(IDD_REMDLG,this);
 remdlg->ShowWindow(SW_SHOW);
}

void CMainWindow::On_M_Scan()
{
 if (REMO || SCAN) return;
 Invalidate();
 COMTest_Single(COM_PORT);if (!COMAvail[COM_PORT]) {MyMsgBox(AppName,commsg00,3);return;}
 //-------------------------
 GetWinPars();Win_XIOpos=XIOpos;Win_YIOpos=YIOpos;
 scandlg=new ScanDlg(this);
 scandlg->Create(IDD_SCANDLG,this);
 scandlg->ShowWindow(SW_SHOW);	 
}
//ICOM_BUS*********************************************************************
int CMainWindow::GetCOMAnswer(int retexp)
{
 int res;

 COM_IsPolling=1;
 IRadio_IB_CmdDel;//Give Radio some ms to respond
 res=comport.AskCOM_SPEC(retexp);
 if (res == retexp) 
  {
   //NBeep();
   return 1;
  }else return 0;
}

void CMainWindow::On_M_ICOMBUS_ResMem() 
{
 char        str[30];
 int         x,fromnum,tonum,error,membank=0;

 if (REMO || SCAN) return;
 if (Radio_Num < 0) {MyMsgBox(AppName,statmsg02,3);return;}
 if (Radio_Num > IRadios_IB_Max || REMO) return;// ONLY ICOM CI-V - Bus
 RadioSettings();
 Invalidate();error=0;
 COMTest_Single(COM_PORT);if (!COMAvail[COM_PORT]) {MyMsgBox(AppName,commsg00,3);return;}
 //-----------------------
 MEMBANK_Dlg membankdlg(this);
 membankdlg.m_bank=membank;
 if (membankdlg.DoModal()==IDOK)
  {
   membank=membankdlg.m_bank+1;
  }else return;
 //-----------------------	
 CLRMEM_Dlg clrmemdlg(this);
 clrmemdlg.m_from="1";
 clrmemdlg.m_to  ="99";
 if (clrmemdlg.DoModal()==IDOK)
  {
   strcpy(str,LPCTSTR(clrmemdlg.m_from));fromnum=atoi(str);
   strcpy(str,LPCTSTR(clrmemdlg.m_to));  tonum  =atoi(str);
  }else return;
 //-----------------------
 comport.Open(COM_PORT,COM_BAUD,COM_DATA,COM_STOP,COM_PARI,COM_PROT,1000,1000);
 comport.ClrRXBuf();comport.ClrTXBuf();
 comport.SwitchVM(1);         GetCOMAnswer(IB_OK);//Bed.: In Memory-Modus schalten
 comport.SetMEM_Bank(membank);GetCOMAnswer(IB_OK);//Bank setzen
 //-----------------------
 if (fromnum < 1) fromnum=1;if (tonum > 99) tonum=99; 
 for (x=fromnum;x < tonum+1;x++) 
  {
   comport.SetMEM_ToNum(x);GetCOMAnswer(IB_OK);VDelay(IRadio_IB_CmdDel);
   comport.SetMEM_CLR();   GetCOMAnswer(IB_OK);VDelay(IRadio_IB_CmdDel);
  }
 comport.Close();
 MyMsgBox(AppName,msg01,2);
}

void CMainWindow::On_M_ICOMBUS_SetMem() 
{
 const        le=500;
 CFileDialog  *OpenDlg;
 CString      FiName("",Fl); 
 char         str[le],str_tmp[le],finame[Fl]="",
              F_tmp[RStrLf],M_tmp[RStrLm]; 
 int          x,i,memnum,membank=0,memcmd=0;

 if (REMO || SCAN) return;
 if (Radio_Num < 0) {MyMsgBox(AppName,statmsg02,3);return;}
 if (Radio_Num > IRadios_IB_Max || REMO) return;// ONLY ICOM CI-V - Bus
 RadioSettings();
 if (IRadio_IB_Da_n   <  5) {MyMsgBox(AppName,msg04,3);return;}
 Invalidate();
 COMTest_Single(COM_PORT);if (!COMAvail[COM_PORT]) {MyMsgBox(AppName,commsg00,3);return;}
 //-----------------------	
 OpenDlg=new CFileDialog(TRUE,NULL,"",OFN_HIDEREADONLY | OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST, 
                         "Memory-Files (*.MEM)|*.mem|All Files (*.*)|*.*||");
 OpenDlg->m_ofn.lpstrTitle="File Open";
 if (OpenDlg->DoModal()== IDOK)
  {
   FiName=OpenDlg->GetPathName();
  }else FiName="";
 delete OpenDlg;
 if (FiName == "") return;
 //-----------------------
 MEMBANK_Dlg membankdlg(this);
 membankdlg.m_bank=membank;
 if (membankdlg.DoModal()==IDOK)
  {
   membank=membankdlg.m_bank+1;
  }else return;
 //-----------------------
 MEMCMD_Dlg memcmddlg(this);
 memcmddlg.m_cmd=memcmd;
 if (memcmddlg.DoModal()==IDOK)
  {
   memcmd=memcmddlg.m_cmd;
  }else return;
 //-TEST------------------
 //FiName="G:\\USER\\Tamm\\A_TAMM\\TA\\ZP\\TaICOM_7\\IC7000_BANK_TEST.MEM";//Test
 //FiName="F:\\ZP_WIN\\TaRad\\TaICOM_7\\MEM_IC7000_BANK_TEST.MEM";//Test
 //membank=5;memcmd=1;//Test
 //-ENDE TEST-------------
 comport.Open(COM_PORT,COM_BAUD,COM_DATA,COM_STOP,COM_PARI,COM_PROT,1000,1000);
 comport.ClrRXBuf();comport.ClrTXBuf();
 strcpy(finame,LPCTSTR(FiName));
 LiReadFile(Fli,1,finame);FliMax=Fli.size();
 comport.SetMEM_Bank(membank);GetCOMAnswer(IB_OK);
 //-----------------------
 for (x=1;x < FliMax+1;x++)
  {
   LiGetElemAt(Fli,str,x);
   if (str[6] == '=' && str[7] == '-') continue;

   strcpy(str_tmp,str);str_tmp[6]=0;
   str_tmp[0]='0';str_tmp[1]='0';StrTrLe(str_tmp,'0');
   memnum=atoi(str_tmp);
   comport.SetMEM_ToNum(memnum);GetCOMAnswer(IB_OK);//Mem-Nummer setzen
   
   comport.SwitchVM(0);GetCOMAnswer(IB_OK);         //In VFO-Modus schalten     
   comport.SwitchVFO(0);GetCOMAnswer(IB_OK);        //VFO A       
                                 
   for (i=0;i < 7;i++) str[i]='x';
   StrTrLe(str,'x');
   GetFM(F_tmp,M_tmp,str);ModFstr(F_tmp,Fdef_s);
   comport.SetFREQ(F_tmp);GetCOMAnswer(IB_OK);      //Frequenz

   GetAddRemData(str,2);//FI
   ModMstr(M_tmp);                                  //Mode
   comport.SetMODE(Mact_n,FIact_n);GetCOMAnswer(IB_OK);
      
   GetAddRemData(str,0);                            //SF
   ModFstr(SFact_s,".001");StrTrLe(SFact_s,' ');
   comport.SetTuStep(SFstrToSFind(SFact_s));GetCOMAnswer(IB_OK);

   DUPsw=0;GetAddRemData(str,4);                    //DUP
   comport.SwitchDUP(DUPsw);GetCOMAnswer(IB_OK);
   
   ATTsw=0;GetAddRemData(str,3);                    //ATT
   comport.SwitchATT(ATTsw);GetCOMAnswer(IB_OK);
   
   PAMPsw=0;GetAddRemData(str,5);                   //PAMP
   comport.SwitchPAMP(PAMPsw);GetCOMAnswer(IB_OK);

   MEMtxt_s[0]=0;GetAddRemData(str,6);              //TXT
   MEMtxt_s[9]=0;
 
   comport.SwitchVFOsEQUAL();GetCOMAnswer(IB_OK);   //VFO A=B
   comport.SetMEM_ToNum(memnum);GetCOMAnswer(IB_OK);

   if (memcmd == 0) 
    {     
     comport.SetMEM_FromVFO();
    }else
    {     
     comport.SetMEM(membank,memnum,F_tmp,Mact_n,FIact_n,DUPsw,MEMtxt_s);     
    }
   GetCOMAnswer(IB_OK);
  }
 //-----------------------
 LiRemAllElem(Fli);
 comport.Close();
 MyMsgBox(AppName,msg01,2);
}

void CMainWindow::On_M_ICOMBUS_Options()
{
 char             str[5];
 ICOM_OPTIONS_Dlg icomoptionsdlg(this);
 
 icomoptionsdlg.m_SM_sel    =SM_sel;
 icomoptionsdlg.m_SQLSM_cont=SQLSM_cont;
 icomoptionsdlg.m_conf      =IRadio_IB_Conf;
 itoa(IRadio_IB_CmdDel,str,10); 
 icomoptionsdlg.m_delay     =str;
 if (icomoptionsdlg.DoModal()==IDOK)
  {
   SM_sel          =icomoptionsdlg.m_SM_sel;
   SQLSM_cont      =icomoptionsdlg.m_SQLSM_cont;
   IRadio_IB_Conf  =icomoptionsdlg.m_conf;
   IRadio_IB_CmdDel=CStrToInt(icomoptionsdlg.m_delay);
   if (IRadio_IB_CmdDel <    0) IRadio_IB_CmdDel=0;
   if (IRadio_IB_CmdDel > 1000) IRadio_IB_CmdDel=1000;
  }else return; 
}
//*****************************************************************************
void CMainWindow::On_M_COM_Settings() 
{
 char tmpstr[9]="";

 if (REMO || SCAN) return; 
 COMSETTINGSDlg comdlg(this);
 if (COM_Poll_Mode == 0) comdlg.m_pollmode=0;else comdlg.m_pollmode=1; 
 itoa(COM_Poll_Interval,tmpstr,10);comdlg.m_polliv=tmpstr; 
 if (comdlg.DoModal()==IDOK)
  {
   if (comdlg.m_pollmode == 0) COM_Poll_Mode=0;else COM_Poll_Mode=1;
   COM_Poll_Interval=CStrToInt(comdlg.m_polliv);
   if (COM_Poll_Interval ==    0) COM_Poll_Interval=10;
   if (COM_Poll_Interval >  1000) COM_Poll_Interval=10;
  }
 Invalidate();UpDateStatusStr(1);UpDateStatusBar();
}

void CMainWindow::On_M_COM_ChPorts() 
{
 if (REMO || SCAN) return;
 COMTest_Complete();	
}

void CMainWindow::On_M_COM_ClrRXBuf() 
{
 if (REMO || SCAN) comport.ClrRXBuf();	
}
//-----------------------------------------------------------------------------
void CMainWindow::On_M_Info() 
{
 ExecNotePad(F_Help);	
}
//-----------------------------------------------------------------------------
void CMainWindow::On_M_About() 
{
 MyMsgBox(AppName,InfoStr,1);		
}
//-----------------------------------------------------------------------------
void CMainWindow::On_M_Exit() 
{
 OnClose();	
}
//-----------------------------------------------------------------------------
void CMainWindow::On_ID_Test() 
{
 // CTRL + SHIFT + T
 NBeep();
 //-------------------------------------------
}
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*
CI-V Transceive=ON to get respond from the radio
//Give Radio some ms to respond

todo:


BUGS:

*/ 
/*
if (PtrToRemDisp != NULL) PtrToRemDisp->PostMessage(WM_REMDISP_FREQCHANGED);
if (PtrToRemDisp != NULL) PtrToRemDisp->PostMessage(WM_REMDISP_STATUSCHANGED);   
*/




